//
//  DiscoverMemLeaksViewController.m
//  DiscoverMemLeaks
//
//  Created by heximal on 10/12/23.
//  Copyright __MyCompanyName__ 2010. All rights reserved.
//

#import "DiscoverMemLeaksViewController.h"

@implementation DiscoverMemLeaksViewController

- (void) doSomethingNow {
	// Uncomment to fix leak:
	//[leakyStringleakyString release];
	
	// Allocate a new string and assign it to a pointer that hasn't been released
	leakyString = [[NSString alloc] initWithUTF8String:"Look, another alloc, but no release!"];
}

- (void)viewDidLoad {
    [super viewDidLoad];
	
	// This is the string that leaks
	leakyString = [[NSString alloc] initWithUTF8String:"I'm a leaky string."];
	LeakedClass * leakyClass = [[LeakedClass alloc] init];
	[leakyClass release];
	[self doSomethingNow];
}

- (void)dealloc {
    [super dealloc];
	
	// This only releases the *2nd* string allocation
	[leakyString release];
}


- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning]; // Releases the view if it doesn't have a superview
    // Release anything that's not essential, such as cached data
}

@end

